#!/bin/sh

#
# KconfigSize tool---automatic makefile generator
# Copyright (C) 2005-2006 NEC-AS/NEC. All rights reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GPLv2, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# SYNOPSIS:
#   ./autogen.sh <ARCH> <additional-configure-parameters...>
#
# DESCRIPTION:
#   you can specify ARCH for cross compilation, if ommitted, default
#   ARCH value will be "i386"
#
# 05/09/27 created by Zetalog <zhengl@sh.necas.nec.com.cn>
# 2006-02-20 Modified by Mingwei Wang <wangmw@sh.necas.nec.com.cn>
#

set -e

# for PATH environment
PATH=$PATH:`pwd`

# for ARCH environment
if [ x"$1" = x"" ] ; then
	ARCH="i386";
else
	ARCH=$1;
	shift;
fi

run_scripts() {
    local cmd=$1
    shift
    local cmd_line=$@

    echo -n "Running $cmd..."
    eval "$cmd_line" > /dev/null 2>&1
    echo "done"
}

run_scripts 'aclocal' 'aclocal'
run_scripts 'autoheader' 'autoheader'
run_scripts 'autoconf' 'autoconf'
run_scripts 'automake' 'automake --copy --foreign --add-missing'
run_scripts 'configure' '$ARCH.configure $@'

