#!/usr/bin/python
#
# KconfigSize tool---make a dict file from category file.
# Copyright (C) 2005-2006 NEC-AS/NEC. All rights reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GPLv2, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# Created by Lei Wang<wlei@sh.nec-as.nec.com.cn>
# 2006-09-01 Modified by Lei Wang<wlei@sh.nec-as.nec.com.cn>
#

import sys,getopt

MENU = "MENU";

#This function is used to print the help message.
#parameter:
#       null
#return value:
#       null
#
def usage():
        print "Usage: make_cate_dict <option>";
	print "make a dictionary from category file.";
	print "-h, --help	print out this message.";
	print "-i, --input	input file name.";
	print "-o, --output	output file name(default: cate_dict).";
	return;

# split a string by two with the first key which not in "()".
# parameter:
#       word:           the string you want to split.
#       key:            the key charactor to split with.
# return :
#       a list of the sub string.
def split(word, key):
        uneffect = 0;
	data = [];
	if word[len(word)-1] == '\n' :
		word = word[0:len(word)-1];
	start = 0;
	for i in range(0, len(word)) :
		if i == len(word)-1 :
			data.append(word[start:]);
			break;
		if word[i] == key and uneffect == 0 :
			data.append(word[start:i]);
			start = i+1;
			if start == len(word) :
				data.append("");
				break;
		elif word[i] == '[' :
			uneffect = uneffect + 1;
		elif word[i] == ']' :
			uneffect = uneffect - 1;
	for i in range(0, len(data)) :
		data[i] = data[i][1:(len(data[i])-1)];
	return data;



#This function is used to output the processed data to the output file.
#parameter:
#       data:           the processed data list.
#       output:         the output file name.
#return value:
#       1               success.
#       0               failed.
#
def saveResult(data, output):
	try :
		file = open(output, 'w');
	except :
		print "can not create with the %s file." % output;
		return 0;
	for items in data :
		file.write("%s,%s\n" % (items[0], items[1]));
	file.close();
	return 1;


#This function is used to process the input category file.
#To make a dict of category for the using of web.
#parameter:
#       input:          the input file name.
#return value:
#       a list of processed data.
#
def process(input):
	try :
		file = open(input, 'r');
	except :
		print "something wrong with the %s file." % input;
		return [-1];
	cate_dict = {};
	data1 = {};
	lines = file.readlines();
	file.close();
	for line in lines :
		items = split(line, ',');
		items[0] = items[0].strip();
		a = items[0].split(' ', 1);
		if a[0] == MENU :
			items[0] = a[1];
		items[1] = items[1].strip();
		a = items[1].split(' ', 1);
		if a[0] == MENU :
			items[1] = a[1];
		if items[1] != "null" :
			data1[items[1]] = items[0];
		if len(items) == 3 :
			items[2] = items[2].strip();
			if items[2] != "null" and items[2] != items[0] :
				data1[items[2]] = items[0];
	keys = data1.keys();
	
	for key in keys :
		b = key;
		a = data1[key];
		if cate_dict.has_key(a) :
			cate_dict[b] = cate_dict[a];
			continue;
		while 1 :
			if a in keys and a != b :
				b = a;
				a = data1[a];
			else :
				if a== b :
					print a;
				cate_dict[key] = b;
				break;

	data = [];
	for key in cate_dict.keys() :
		data.append(["[%s]" % key, "[%s]" % cate_dict[key]]);
	return data;


def main ():
	try :
		(opts, str) = getopt.gnu_getopt(sys.argv[1:], "hi:o:", ["help","input=","output="]);
	except :
		usage();
		return;

	inFile = "";
	outFile = "cate_dict";
	for (opt, arg) in opts :
		if opt in ("-h", "--help") :
			usage();
			return;
		elif opt in ("-i", "--input") :
			inFile = arg;
		elif opt in ("-o", "--output") :
			outFile = arg;
		else :
			usage();
			return;
			
	results = process(inFile);
	if results == [-1] :
		return;
	saveResult(results, outFile);


if __name__ == "__main__" :
	main();
