#!/usr/bin/python

#
# KconfigSize tool---distilling individual impact by configuration items
# Copyright (C) 2005-2006 NEC-AS/NEC. All rights reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GPLv2, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# Created by Fan Wu<wuf@sh.necas.nec.com.cn>
# 2006-02-20 Modified by Fan Wu <wuf@sh.necas.nec.com.cn>
#

import sys
import os
import getopt

def usage():
	print "indiv -t <type> input output"
	print "type can be \"size\" or \"mem\""
	return
	
def configsInSet(set, configs) :
	configs_array = configs.split('+')
	set_array = set.split('+')
	for config in configs_array :
		if config not in set_array : 
			return False
	return True

def splitConfigs(set, configs) :
	configs_array = configs.split('+')
	set_array = set.split('+')
	subConfig = []
	for item in set_array :
		if item not in configs_array : 
			subConfig.append(item)
	return subConfig

class Data(object):
	data = {}
	none_data = {}
	conditions = []
	title = []
	sort = []
	base_size1=''
	base_size2=''
	base_size3=''

	def __init__(self) :
		object.__init__(self)
	def output(self,output_file,type) :
		f = open(output_file,"w")

		# output the title
		for item in Data.title:
			f.write(item)
			f.write('\n')
	  		
		# output base size
		f.write('BASE,')
		if type == 'size' :
			f.write(Data.base_size1)
			f.write(',')
			f.write(Data.base_size2)
		else : 
			f.write(Data.base_size1)
			f.write(',')
			f.write(Data.base_size2)
			f.write(',')
			f.write(Data.base_size3)
		f.write('\n')
		
		# output the data
		num = 1
		while num <= len(Data.data.items()):
		    # sort according to the input order
			for element, value in Data.data.items() :
				index = value['index']
				if int(index) == num :
					if type == 'size' :
						size1 = value['size1']
						size2 = value['size2']
						f.write(element+","+str(size1)+","+str(size2))
					else: 
						size1 = value['size1']
						size2 = value['size2']
						size3 = value['size3']
						f.write(element+","+str(size1)+","+str(size2)+","+str(size3))
					
					f.write("\n")
					num = num + 1
					break;
		for item in Data.conditions:
			f.write(item)
			f.write("\n")
		f.close()
		
	def process(self,file,type) :
		try: 
			f = open(file,"r")
		except: 
			print "file can't be opened: %s" % file
			return
		num = 2
		title_flag = False
		# Get the data from input file and store in dict
		for line in f.readlines():
			line = line.strip()
			line = line.split(',')

			#strip space/tab of every element in a single line
			before_strip = line
			i = 0
			while i < len(before_strip):
				line[i] = before_strip[i].strip()
				i=i+1
				
			#if line is null, just break
			if line[0] == '' :
				continue;

			#handle title 
			if not line[0].isdigit():
				templine = line[0].strip()
				if templine == 'index':
					if type == 'size' :
						templine = 'items,effect(raw),effect(compress)'
					else :
						templine = 'items,effect(used),effect(free),effect(totoal)'
					Data.title.append(templine)
					title_flag = True
					continue;
					
				newline =' '
				for item in line:
					if newline == ' ':
						newline = item
					else :
						newline= newline + ","+ item.strip()
				
				if title_flag == False : 
					Data.title.append(newline)
				else :
					Data.conditions.append(newline)
				continue;
			
			# handle data
			if line[0] == '0' :
				if not line[3].isdigit() :
					print "No base data detected, Indiv process abort! Please check data and retry"
					sys.exit(1)
					
				if type == 'size' :
					Data.base_size1 = line[3]
					Data.base_size2 = line[4]
				else : 
					Data.base_size1 = line[3]
					Data.base_size2 = line[4]
					Data.base_size3 = line[5]
			else :
				key = line[2]
				index = line[0]
				if type == 'size' :
					if not line[3].isdigit() :
						value = {'index': index, 'size1': 'NONE', 'size2': 'NONE'}
						Data.none_data[key] = value
					else :
						size1 = int(line[3]) - int(Data.base_size1)
						size2 = int(line[4]) - int(Data.base_size2)
						value = {'index': index, 'size1': size1, 'size2': size2 }
						Data.data[key] = value
				else : 
					if not line[3].isdigit() :
						value = {'index': index, 'size1': 'NONE', 'size2': 'NONE', 'size3' : 'NONE' }
						Data.none_data[key] = value
					else :
						size1 = int(line[3]) - int(Data.base_size1)
						size2 = int(line[4]) - int(Data.base_size2)
						size3 = int(line[5]) - int(Data.base_size3)
						value = {'index': index, 'size1': size1, 'size2': size2, 'size3' : size3 }
						Data.data[key] = value
		
		# process dict to get individual data
		change = True 			
		while change:
			change = False
			CURSOR = EXTENT = Data.data.items()
			for cursor_key,cursor_value in CURSOR:
				if change :
					break;
				for element_key, element_value in EXTENT:
					if cursor_key == element_key:
						continue;
					if configsInSet(element_key, cursor_key) :
						temp = splitConfigs(element_key,cursor_key)
						if not temp:
							break;
						new_element_key =temp[0]
						for i in range(1,len(temp)):
							new_element_key=new_element_key+'+'+temp[i]	
						
						new_element_value={}
						new_element_value['index'] = element_value['index']
						new_element_value['size1'] = str(int(element_value['size1']) - int(cursor_value['size1']))
						new_element_value['size2'] = int(element_value['size2']) - int(cursor_value['size2'])
						
						if type != 'size' :
							new_element_value['size3'] = int(element_value['size3']) - int(cursor_value['size3'])
							
						del Data.data[element_key]
						Data.data[new_element_key] = new_element_value
						
						change = True
						break;
						
	    # add 'NONE' data into the dict					
		for key, value in Data.none_data.items():
			Data.data[key] = value
				
def main(argv):
	(opts,args) = getopt.getopt(argv[1:],"ht:",["help","type="])
	if(len(args)!= 2) :
		usage()
		sys.exit()
		
	for opt,value in opts :
		if opt in ("-t","--type"):
			type = value;
		if opt in ("-h","--help"):
			usage()
			sys.exit()
	
	input=args[0]
	output=args[1]
	type = str(type)	
	if type != 'size' and type != 'mem' :
		print "not equal"
		usage()
		sys.exit()
		
	data = Data()
	data.process(input,type)
	data.output(output,type)

if __name__ == '__main__' :
	main(sys.argv)
