#!/usr/bin/python
#
# KconfigSize tool---to describe the result with a web form.
# Copyright (C) 2005-2006 NEC-AS/NEC. All rights reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GPLv2, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# Created by Lei Wang<wlei@sh.nec-as.nec.com.cn>
# 2006-08-17 Modified by Lei Wang<wlei@sh.nec-as.nec.com.cn>
#

import sys, os, commands, string
import gdchart, shelve

# global variable about db
CP_FAIL = "CP_FAIL";
MEM_FAIL = "MEM_FAIL";

# global variable about category
MENU = "MENU";

# global variable about drawing picture
LINE_WIDTH = 512;
LINE_HEIGHT = 256;
CHART_WIDTH = 300;
CHART_HEIGHT = 550;
sub_title = ["Vmlinux", "bzImage", "total mem", "used mem", "free mem"];
sortWay = "";

# global variable about page content
top = "";
UNIT = "(unit: byte)";
END = "</body></html>";
REFERENCE = '''<p>Reference : undefined means the kernel can be compiled successfully, but can't run.<br>
&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp failed means the kernel can't be compiled successfully.</p>''';
NODATA = "<p>There is no data can be print.</p>";

raw_sm =  "<tr><td align=center>Config Item<br>\
<input type=button value=sort onClick=mysort(0,1)></td><td align=center>Vmlinux<br>\
<input type=button value=sort onClick=mysort(1,1)></td><td align=center>bzImage<br>\
<input type=button value=sort onClick=mysort(2,1)></td><td align=center>total mem<br>\
<input type=button value=sort onClick=mysort(3,1)></td><td align=center>used mem<br>\
<input type=button value=sort onClick=mysort(4,1)></td><td align=center>free mem<br>\
<input type=button value=sort onClick=mysort(5,1)></td></tr>";

raw_size =  "<tr><td align=center>Config Item<br>\
<input type=button value=sort onClick=mysort(0,1)></td><td align=center>Vmlinux<br>\
<input type=button value=sort onClick=mysort(1,1)></td><td align=center>bzImage<br>\
<input type=button value=sort onClick=mysort(2,1)></td></tr>";

raw_mem =  "<tr><td align=center>Config Item<br>\
<input type=button value=sort onClick=mysort(0,1)></td><td align=center>total mem<br>\
<input type=button value=sort onClick=mysort(1,1)></td><td align=center>used mem<br>\
<input type=button value=sort onClick=mysort(2,1)></td><td align=center>free mem<br>\
<input type=button value=sort onClick=mysort(3,1)></td></tr>";

raw_base_sm =  "<tr><td align=center>Config Item<br>\
<input type=button value=sort onClick=mysort(0,2)></td><td align=center>Vmlinux<br>\
<input type=button value=sort onClick=mysort(1,2)></td><td align=center>bzImage<br>\
<input type=button value=sort onClick=mysort(2,2)></td><td align=center>total mem<br>\
<input type=button value=sort onClick=mysort(3,2)></td><td align=center>used mem<br>\
<input type=button value=sort onClick=mysort(4,2)></td><td align=center>free mem<br>\
<input type=button value=sort onClick=mysort(5,2)></td></tr>";

raw_base_size =  "<tr><td align=center>Config Item<br>\
<input type=button value=sort onClick=mysort(0,2)></td><td align=center>Vmlinux<br>\
<input type=button value=sort onClick=mysort(1,2)></td><td align=center>bzImage<br>\
<input type=button value=sort onClick=mysort(2,2)></td></tr>";

raw_base_mem =  "<tr><td align=center>Config Item<br>\
<input type=button value=sort onClick=mysort(0,2)></td><td align=center>total mem<br>\
<input type=button value=sort onClick=mysort(1,2)></td><td align=center>used mem<br>\
<input type=button value=sort onClick=mysort(2,2)></td><td align=center>free mem<br>\
<input type=button value=sort onClick=mysort(3,2)></td></tr>";

effect_sm =  "<tr><td align=center>Enabled Config Item<br>\
<input type=button value=sort onClick=mysort(0,0)></td><td align=center>Vmlinux<br>\
<input type=button value=sort onClick=mysort(1,0)></td><td align=center>bzImage<br>\
<input type=button value=sort onClick=mysort(2,0)></td><td align=center>total mem<br>\
<input type=button value=sort onClick=mysort(3,0)></td><td align=center>used mem<br>\
<input type=button value=sort onClick=mysort(4,0)></td><td align=center>free mem<br>\
<input type=button value=sort onClick=mysort(5,0)></td></tr>";

effect_size =  "<tr><td align=center>Enabled Config Item<br>\
<input type=button value=sort onClick=mysort(0,0)></td><td align=center>Vmlinux<br>\
<input type=button value=sort onClick=mysort(1,0)></td><td align=center>bzImage<br>\
<input type=button value=sort onClick=mysort(2,0)></td></tr>";

effect_mem =  "<tr><td align=center>Enabled Config Item<br>\
<input type=button value=sort onClick=mysort(0,0)></td><td align=center>total mem<br>\
<input type=button value=sort onClick=mysort(1,0)></td><td align=center>used mem<br>\
<input type=button value=sort onClick=mysort(2,0)></td><td align=center>free mem<br>\
<input type=button value=sort onClick=mysort(3,0)></td></tr>";

base_sm =  "<tr><td align=center>Description</td>\
<td align=center>Vmlinux</td>\
<td align=center>bzImage</td>\
<td align=center>total mem</td>\
<td align=center>used mem</td>\
<td align=center>free mem</td></tr>";

base_size =  "<tr><td align=center>Description</td>\
<td align=center>Vmlinux</td>\
<td align=center>bzImage</td></tr>";

base_mem =  "<tr><td align=center>Description</td>\
<td align=center>total mem</td>\
<td align=center>used mem</td>\
<td align=center>free mem</td></tr>";

raw_showitem =  "<tr><td align=center>Index</td>\
<td align=center>Condition</td>\
<td align=center>Vmlinux</td>\
<td align=center>bzImage</td>\
<td align=center>total mem</td>\
<td align=center>used mem</td>\
<td align=center>free mem</td></tr>";

effect_showitem =  "<tr><td align=center>Index</td>\
<td align=center>Condition</td>\
<td align=center>Vmlinux</td>\
<td align=center>bzImage</td>\
<td align=center>total mem</td>\
<td align=center>used mem</td>\
<td align=center>free mem</td></tr>";

base_showitem =  "<tr><td align=center>Index</td>\
<td align=center>Condition</td>\
<td align=center>Vmlinux</td>\
<td align=center>bzImage</td>\
<td align=center>total mem</td>\
<td align=center>used mem</td>\
<td align=center>free mem</td></tr>";

# make the header of the page being requested
# parameter :
#	type:		the type of the requested page
# return :
# 	void
def header(type="text/html") :
	sys.stdout.write("Content-type: %s\r\n\r\n" % type);


# make the title of the page being requested
# parameter :
#	title:		the title name
# return :
# 	void
def printTitle(title="Welcome!") :
	print "<html><head><title>%s</title></head>" % title;
	print "<body>";


# make the script of the page being requested
# parameter :
#	script:		the script content
# return :
# 	void
def printScript(script="") :
	print "<script language=javascript>%s</script>" % script;


# make the table to display category
# parameter :
#	cates:		category to display
# return :
# 	void
def printCateTable(cates) :
	print "<p><table border=1>";
	print "<tr align=center><td>Category:<br><br>";
	for cate in cates :
		print "%s<br>" % cate;
	print "</td></tr></table></p>";


# make the options of Size, Mem and All
# parameter :
#	sm:		tell us which option is default selected
# return :
# 	void
def printSmOptions(sm) :
	print "Size/Mem:<select name=sm>";
	print "<option>All</option>";
	if sm == "Size" :
		print "<option selected>Size</option>";
		print "<option>Mem</option>";
	elif sm == "Mem" :
		print "<option>Size</option>";
		print "<option selected>Mem</option>";
	else :
		print "<option>Size</option>";
		print "<option>Mem</option>";
	print "</select>";


# make the options of Raw, Impact and All
# parameter :
#	re:		tell us which option is default selected
# return :
# 	void
def printReOptions(re) :
	print "Total/Isolated impact:<select name=re>";
	print r'<option value="All">All</option>';
	if re == "Raw" :
		print r'<option value="Raw" selected>Total</option>';
		print r'<option value="Impact">Isolated</option>';
	elif re == "Impact" :
		print r'<option value="Raw">Total</option>';
		print r'<option value="Impact" selected>Isolated</option>';
	else :
		print r'<option value="Raw">Total</option>';
		print r'<option value="Impact">Isolated</option>';
	print "</select>";


# make the table of raw or effect data
# parameter :
#	id:		the table id
#	items:		the data to print
#	re:		the table type(raw, raw_base or effect)
#	sm:		the data type(Size, Mem or All)
#	title:		the table title
# return :
# 	void
def printTable(id, items, re, sm, title="") :
	print "<table id='%s' border=1>" % id;
	if sm == "Size" :
		if title != "" :
			print title;
		elif re == "raw" :
			print raw_size;
		elif re == "effect" :
			print effect_size;
		else :
			print raw_base_size;
		for key in items :
			if key[0] == "NONE" or key[0] == "BASE" :
				continue;
			print "<tr><td>%s</td>" % key[0];
			if key[1] == CP_FAIL :
				for i in range(1, 3) :
					print "<td>failed</td>";
				print "</tr>";
				continue;
			for i in range(1, 3) : 
				print "<td>%s</td>" % key[i];
			print "</tr>";
	elif sm == "Mem" :
		if title != "" :
			print title;
		elif re == "raw" :
			print raw_mem;
		elif re == "effect" :
			print effect_mem;
		else :
			print raw_base_mem;
		for key in items :
			if key[0] == "NONE" or key[0] == "BASE" :
				continue;
			print "<tr><td>%s</td>" % key[0];
			if key[3] == CP_FAIL :
				for i in range(1, 4) :
					print "<td>failed</td>";
				print "</tr>";
				continue;
			if key[3] == MEM_FAIL :
				for i in range(1, 4) :
					print "<td>undefined</td>";
				print "</tr>";
				continue;
			for i in range(3, 6) :
				print "<td>%s</td>" % key[i];
			print "</tr>";
	else :
		if title != "" :
			print title;
		elif re == "raw" :
			print raw_sm;
		elif re == "effect" :
			print effect_sm;
		else :
			print raw_base_sm;
		for key in items :
			if key[0] == "NONE" or key[0] == "BASE" :
				continue;
			print "<tr><td>%s</td>" % key[0];
			if key[1] == CP_FAIL :
				for i in range(1, 6) :
					print "<td>failed</td>";
				print "</tr>";
				continue;
			for i in range(1, 3) :
				print "<td>%s</td>" % key[i];
			if key[3] == MEM_FAIL :
				for i in range(1, 4) :
					print "<td>undefined</td>";
				print "</tr>";
				continue;
			for i in range(3, 6) :
				print "<td>%s</td>" % key[i];
			print "</tr>";
	print "</table>";
	

# make the table of raw or effect compareing data of two versions
# parameter :
#	id:		the table id
#	items1:		the data of source version
#	items2:		the data of target version
#	re:		the table type(raw or effect)
#	sm:		the data type(Size, Mem or All)
#	title:		the table title
# return :
# 	void
def printCmpTable(id, items1, items2, re, sm, title="") :
	hash = {};
	for item in items2 :
		hash[item[0]] = item[1:];

	print "<table id='%s' border=1>" % id;
	if sm == "Size" :
		if title != "" :
			print title;
		elif re == "raw" :
			print raw_size;
		elif re == "effect" :
			print effect_size;
		else :
			print raw_base_size;
		for key in items1 :
			if not hash.has_key(key[0]) :
				continue;
			if key[0] == "NONE" or key[0] == "BASE" :
				continue;
			print "<tr><td>%s</td>" % key[0];
			if key[1] == CP_FAIL or hash[key[0]][0] == CP_FAIL :
				for i in range(1, 3) :
					print "<td>failed</td>";
				print "</tr>";
				continue;
			for i in range(1, 3) :
				print "<td>%d</td>" % (-1 * (int(key[i]) - int(hash[key[0]][i-1])));
			print "</tr>";
	elif sm == "Mem" :
		if title != "" :
			print title;
		elif re == "raw" :
			print raw_mem;
		elif re == "effect" :
			print effect_mem;
		else :
			print raw_base_mem;
		for key in items1 :
			if not hash.has_key(key[0]) :
				continue;
			if key[0] == "NONE" or key[0] == "BASE" :
				continue;
			print "<tr><td>%s</td>" % key[0];
			if key[3] == CP_FAIL or hash[key[0]][2] == CP_FAIL :
				for i in range(1, 4) :
					print "<td>failed</td>";
				print "</tr>";
				continue;
			if key[3] == MEM_FAIL or hash[key[0]][2] == MEM_FAIL :
				for i in range(1, 4) :
					print "<td>undefined</td>";
				print "</tr>";
				continue;
			for i in range(3, 6) :
				print "<td>%d</td>" % (-1 * (int(key[i]) - int(hash[key[0]][i-1])));
			print "</tr>";
	else :
		if title != "" :
			print title;
		elif re == "raw" :
			print raw_sm;
		elif re == "effect" :
			print effect_sm;
		else :
			print raw_base_sm;
		for key in items1 :
			if not hash.has_key(key[0]) :
				continue;
			if key[0] == "NONE" or key[0] == "BASE" :
				continue;
			print "<tr><td>%s</td>" % key[0];
			if key[1] == CP_FAIL or hash[key[0]][0] == CP_FAIL :
				for i in range(1, 6) :
					print "<td>failed</td>";
				print "</tr>";
				continue;
			for i in range(1, 3) :
				print "<td>%d</td>" % (-1 * (int(key[i]) - int(hash[key[0]][i-1])));
			if key[3] == MEM_FAIL or hash[key[0]][2] == MEM_FAIL :
				for i in range(1, 4) :
					print "<td>undefined</td>";
				print "</tr>";
				continue;
			for i in range(3, 6) :
				print "<td>%d</td>" % (-1 * (int(key[i]) - int(hash[key[0]][i-1])));
			print "</tr>";
	print "</table>";


# show a error message page
# parameter :
#	message:	the error message string
#	link:		where to go back to
# return :
#	void
def error(message="There is a error!", link="null") :
	printTitle("Error!");
	print "<p><center>%s<br><br>" % message;
	if link == "null" :
		print "</center></p>";
	else :
		print "please click <a href='%s?'>here</a> to go back!</center></p>" % link;
	print END;


# check wheather a string can be tranform to int.
# parameter :
#	word:		the tring to check.
# return :
# 	1:		we can.
#	0:		we can not.
def isDigit(word) :
	if word.isdigit() :
		return 1;
	if word.startswith("-") and word[1:].isdigit() :
		return 1;
	return 0;


# check wheather we can get the Image or not.
# parameter :
#	items:		the data that the Image to describe.
#	sm:		the condition of what kind of data will be describe.
# return :
# 	1:		we can.
#	0:		we can not.
def haveImage(items, sm) :
	for item in items :
		if item[0] == "BASE" or item[0] == "NONE" :
			continue;
		if sm == "Size" and isDigit(item[1]) :
			return 1;
		elif sm == "Mem" and isDigit(item[3]) :
			return 1;
		elif isDigit(item[1]) and isDigit(item[3]) :
			return 1;
	
	return 0;


# check wheather we can get the compareing Image of two tests or not.
# parameter :
#	items1:		the data of test1.
#	items2:		the data of test2.
#	sm:		the condition of what kind of data will be describe.
# return :
# 	1:		we can.
#	0:		we can not.
def haveCmpImage(items1, items2, sm) :
	hash = {};
	for item in items2 :
		hash[item[0]] = item[1:];
	for item in items1 :
		if item[0] == "BASE" or item[0] == "NONE" :
			continue;
		if sm == "Size" and isDigit(item[1]) :
			if hash.has_key(item[0]) and isDigit(hash[item[0]][0]) :
				return 1;
		elif sm == "Mem" and isDigit(item[3]) :
			if hash.has_key(item[0]) and isDigit(hash[item[0]][2]) :
				return 1;
		elif isDigit(item[1]) and isDigit(item[3]) :
			if hash.has_key(item[0]) and isDigit(hash[item[0]][0]) and isDigit(hash[item[0]][2]) :
				return 1;
	return 0;


# check wheather we have some data data to print and what kind of data there is.
# parameter :
#	items:		the data list that maybe can be printed.
#	sm:		the condition of what kind of data will be print.(Size, Mem or All)
# return :
#	3:		we have, but just have mem data.
#	2:		we have, but just have size data.
# 	1:		we have all.
#	0:		we have not.
def haveData(items, sm) :
	for item in items :
		if sm == "Size" and item[1] == '' :
			return 0;
		elif sm == "Mem"  and item[3] == '' :
			return 0;
		else : 
			if item[1] == '' and item[3] == '' :
				return 0;
			if item[1] == '' :
				return 3;
			if item[3] == '' :
				return 2;
	if len(items) == 0 :
		return 0;
	else :
		return 1;


# print out a table describe the base size of the test.
# parameter :
#       base:           base data list.
#       sm:             the condition of what kind of data will be describe.
# return :
#       void
def printBaseTable(base, sm) :
        print "<table border=1>";
	if sm == "Size" :
		print base_size;
		for j in range(0, len(base)) :
			print "<tr>";
			for i in range(0, 3) :
				print "<td>%s</td>" % base[j][i];
			print "</tr>";
	elif sm == "Mem" :
		print base_mem;
		for j in range(0, len(base)) :
			print "<tr>";
			print "<td>%s</td>" % base[j][0];
			for i in range(3, 6) :
				print "<td>%s</td>" % base[j][i];
			print "</tr>";
	else :
		print base_sm;
		for j in range(0, len(base)) :
			print "<tr>";
			for i in range(0, 6) :
				print "<td>%s</td>" % base[j][i];
			print "</tr>";
	print "</table>";


# to draw the chart
# parameter :
#	data:		the data want to be drawn.
#       title:		the title of the chart.
#       sm:		the condition of what kind of data will be drawn.
#       re:		the type of the data will be drawn.
#       xtitle:		the xtitle of the chart.
# return :
#	void
def drawChart(data, title, sm, re, xtitle="") :
	confChart = gdchart.Bar3D();
	confChart.width = 21 * len(data[0]) + CHART_WIDTH;
	confChart.height =7 * len(data[0]) + CHART_HEIGHT;
	confChart.title = title;
	confChart.set_color = ["white", "blue", "green", "yellow", "red"];
	if sm == "Size" :
		confChart.setData(data[2], data[1]);
		if xtitle != "" :
			confChart.xtitle = xtitle;
		else :
			confChart.xtitle = "white: bzImage\n" \
				"blue: Vmlinux";
	elif sm == "Mem" :
		confChart.setData(data[2], data[3], data[1]);
		if xtitle != "" :
			confChart.xtitle = xtitle;
		else :
			confChart.xtitle = "white: used mem\n" \
				"blue: free mem\n" \
				"green: total mem";
	else :
		confChart.setData(data[2], data[1], data[4], data[5], data[3]);
		if xtitle != "" :
			confChart.xtitle = xtitle;
		else :
			confChart.xtitle = "white: bzImage\n" \
				"blue: Vmlinux\n" \
				"green: used mem\n" \
				"yellow: free mem\n" \
				"red: total mem";

	confChart.setLabels(data[0]);
	confChart.draw(sys.stdout);


# caculate the result of raw data minusing base.
# parameter :
#	items:		raw data.
#       base:           base data.
#       sm:             the condition of what kind of data will be caculate.
# return :
#       a list of data.
def getRawBase(items, base, sm) :
	data = [];
	for item in items :
		if sm == "Size" and isDigit(item[1]) :
			for i in range(1, 3) :
				item[i] = str(int(item[i]) - int(base[i-1]));
			data.append(item);
		elif sm == "Mem" and isDigit(item[3]) :
			for i in range(3, 6) :
				item[i] = str(int(item[i]) - int(base[i-1]));
			data.append(item);
		elif isDigit(item[1]) and isDigit(item[3]) :
			for i in range(1, 6) :
				item[i] = str(int(item[i]) - int(base[i-1]));
			data.append(item);
	return data;


# compare function for kernel version
def compare_ver(a, b) :
	arch_a, mach_a, ver_a, gcc_a, baseconf_a, dbname_a = a.split("-", 5);
	arch_b, mach_b, ver_b, gcc_b, baseconf_b, dbname_b = b.split("-", 5);
	vers_a = ver_a.split(".");
	vers_b = ver_b.split(".");
	for i in range(0, len(vers_a)) :
		if i >= len(vers_b) :
			return 1;
		if int(vers_a[i]) == int(vers_b[i]) :
			continue;
		if int(vers_a[i]) > int(vers_b[i]) :
			return 1;
		if int(vers_a[i]) < int(vers_b[i]) :
			return -1;

	if i < len(vers_b)-1 :
		return -1;
	
	if dbname_a > dbname_b :
		return 1;
	else :
		return -1;


# comare function for custom condition,this function use the global variable sortWay
# set by the call function.
def compare_custom(a, b) :
	index, isAscend = sortWay.split("_", 1);
	index = int(index);
	isAscend = int(isAscend);
	if index == 0 :
		if isAscend == 1 :
			if a[0] > b[0] :
				return 1;
			else :
				return -1;
		else :
			if a[0] > b[0] :
				return -1;
			else :
				return 1;
		
	if isAscend == 1 :
		if int(a[index]) > int(b[index]) :
			return 1;
		elif int(a[index]) < int(b[index]) :
			return -1;
	else :
		if int(a[index]) > int(b[index]) :
			return -1;
		elif int(a[index]) < int(b[index]) :
			return 1;
	
	if a[0] > b[0] :
		return 1;
	else :
		return -1;


# split a string by two with the first key which not in "()".
# parameter:
# 	word:		the string you want to split.
# 	key:		the key charactor to split with.
# return :
#	a list of the sub string.
def split(word, key):
	uneffect = 0;
	data = [];
	if word[len(word)-1] == '\n' :
		word = word[0:len(word)-1];
	start = 0;
	for i in range(0, len(word)) :
		if i == len(word)-1 :
			data.append(word[start:]);
			break;
		if word[i] == key and uneffect == 0 :
			data.append(word[start:i]);
			start = i+1;
			if start == len(word) :
				data.append("");
				break;
		elif word[i] == '[' :
			uneffect = uneffect + 1;
		elif word[i] == ']' :
			uneffect = uneffect - 1;
	return data;


# make a dict about category.
# parameter:
# 	cate_file:		category file's content.(list of lines)
# return :
#	a dict of the category file.
def make_dict(cate_file):
	cate_dict = {};
	for line in cate_file :
		items = split(line, ',');
		if len(items) < 2 :
			return {};
		items[0] = items[0].strip();
		items[1] = items[1].strip();
		cate_dict[items[0][1:(len(items[0])-1)]] = items[1][1:(len(items[1])-1)];
	return cate_dict;


# get all focusitems of one version
# parameter :
#	db_name:		database file name
# return:
#	focusitems list
def get_all_focusitems(db_name):
        all_focusitems = []
	# open db files
	db = shelve.open(db_name, 'r')
	# get all focus items from raw or effect db file
	allkeys = db.keys()
	for key in allkeys:
		keyfield = key.split('-')
		if keyfield[6] == "effect" :
			continue;
		item = keyfield[5];
		effectitem = item.split('+')
		# filter NONE and BASE config items
		if effectitem[0] != 'NONE' and effectitem[0] != 'BASE' and not effectitem[0] in all_focusitems:
			all_focusitems.append(effectitem[0])
	# close files
	db.close()
	return all_focusitems


# get category of one version
# parameter :
#	db_name:		database file name
#	cate_name:		category file name
# return :
#	category list
def get_category(db_name, cate_name):
        focusitems = []
	cate_list = []
	# open category files
	try :
		category = open(cate_name, 'r')
	except :
		return cate_list;
	# get all focus items from db file
	focusitems = get_all_focusitems(db_name)
	# match focus items in the category file
	lines = category.readlines()
	cate_dict = make_dict(lines);
	if cate_dict == {} :
		return cate_list;

	for focusitem in focusitems:
		if not cate_dict.has_key(focusitem) :
			print focusitem;
			return [];
		item = cate_dict[focusitem];
		if not item in cate_list:
			cate_list.append(item)

	# close files
	category.close()
	return cate_list


# get items belong to some categories of one version
# parameter :
#	cate_name:		category file name
#	catelist:		category list
# return :
#	focusitems list
def get_focusitems(cate_name, catelist):
        focusitems = []
	# open category files
	try :
		category = open(cate_name, 'r')
	except :
		return [-1];
	lines = category.readlines()
	cate_dict = make_dict(lines);
	if cate_dict == {} :
		return [-1];
	keys = cate_dict.keys();
	for key in keys :
		if cate_dict[key] in catelist :
			focusitems.append(key);
	# close files
	category.close()
	return focusitems


# get the configure item from confdb that match the cond and belone to the cates
# parameter :
#	result_dir:	result dir of your test
#	category_file:	category file name of your test
#	confdb_name:	the db file's name of the test
#	cond:		the string with format as arch-mach-ver-gcc-baseconfig
#	caters:		a list of categories such as "Device Drivers" etc.
# return :
#	a list contain two lists which have the configure item's name as its keyword 
#	and the item's data as its data.
def getConfItem(result_dir, category_file, dbname, cond, cates) :
	arch, mach, ver, gcc, baseconf = cond.split("-", 4);
	if cates[0] != "All" :
		cate_path = dbname[0:-2] + "cat";
		focusitems = get_focusitems(cate_path, cates);
		if focusitems == [-1] :
			return [-1];
		focusitems.append("BASE");
		focusitems.append("NONE");
	else :
		focusitems = [];

	confdb = shelve.open(dbname, flag='r');
	keys = confdb.keys();
	items = [];
	items_r = [];
	items_e = [];

	for key in keys :
		arch_item, mach_item, ver_item, gcc_item, baseconf_item, conf_item, \
			re_item = key.split("-", 6);
		confs = conf_item.split('+');
		if confs[0] in focusitems or cates[0] == "All" :
			if re_item == "raw" :
				items_r.append(confdb[key]);
				items_r[len(items_r)-1].insert(0, conf_item);
			if re_item == "effect" :
				items_e.append(confdb[key]);
				items_e[len(items_e)-1].insert(0, conf_item);
	
	items_r.sort();
	items_e.sort();
	items.append(items_r);
	items.append(items_e);
	confdb.close();
	return items;


# for drawing picture, get the data list of config item with a particular form. the config item match both cond1 and
# cond2. the data is data of cond1's config item minusing data of cond2's config item.
# parameter :
#	result_dir:	result dir of your source and target test
#	category_file:	category file name of your source and target test
#	confdb_name1:	the db file's name of the source test
#	confdb_name2:	the db file's name of the target test
#	cond1:		the string with format as arch-mach-ver-gcc-baseconfig about source
#	cond2:		the string with format as arch-mach-ver-gcc-baseconfig about target
#	caters:		a list of categories such as "Device Drivers" etc.
#	sm:		the wanted data type(Size, Mem or All)
#	re:		the wanted data type(raw or effect)
#	sort_by:	the sort condition. it's format just like "3_0". the first number
#			is the sort index, where as the second number is the sort way. 1
#			means Ascendent while 0 means Descendent.
# return :
#	a tuple with the form such as ([item1_name,item2_name,...], [item1_data[0],item2_data[0],...], 
#	[item1_data[1],item2_data[1],...], [item1_data[2],item2_data[2],...], 
#	[item1_data[3],item2_data[3],...], ...,[item1_data[n],item2_data[n],...]).
def getCmpConfData(result_dir, category_file, confdb_name1, confdb_name2, cond1, cond2, cates, sm, re, sort_by) :
	global sortWay;
	arch1, mach1, ver1, gcc1, baseconf1 = cond1.split("-", 4);
	if cates[0] != "All" :
		cate_path = confdb_name1[0:-2] + "cat";
		focusitems1 = get_focusitems(cate_path, cates);
		focusitems1.append("BASE");
		focusitems1.append("NONE");
	else :
		focusitems1 = [];
	arch2, mach2, ver2, gcc2, baseconf2 = cond2.split("-", 4);
	if cates[0] != "All" :
		cate_path = confdb_name2[0:-2] + "cat";
		focusitems2 = get_focusitems(cate_path, cates);
		focusitems2.append("BASE");
		focusitems2.append("NONE");
	else :
		focusitems2 = [];
		
	confdb1 = shelve.open(confdb_name1, flag='r');
	confdb2 = shelve.open(confdb_name2, flag='r');

	keys1 = confdb1.keys();
	data1 = [];
	base_data1 = [];
	base_data2 = [];
	i = 0;
	for key in keys1 :
		arch_item, mach_item, ver_item, gcc_item, baseconf_item, conf_item, \
			re_item = key.split("-", 6);
		item = "-".join([arch_item, mach_item, ver_item, gcc_item, baseconf_item]);
		confs = conf_item.split('+');
		if re_item == re and (confs[0] in focusitems1 or cates[0] == "All") :
			if conf_item == "BASE" :
				continue;
			if conf_item == "NONE" :
				base_data1 = confdb1[key];
				continue;
			s = [];
			if sm == "Size" :
				if confdb1[key][0] == CP_FAIL :
					continue;
				for k in range(0,2) :
					s.append(confdb1[key][k]);
			elif sm == "Mem" :
				if CP_FAIL in confdb1[key] or MEM_FAIL in confdb1[key] :
					continue;
				for k in range(2,5) :
					s.append(confdb1[key][k]);
			else :
				if CP_FAIL in confdb1[key] or MEM_FAIL in confdb1[key] :
					continue;
				for k in range(0,5) :
					s.append(confdb1[key][k]);
			s.insert(0, conf_item);
			data1.append(s);
	confdb1.close();
			
	keys2 = confdb2.keys();
	data2 = {};
	for key in keys2 :
		arch_item, mach_item, ver_item, gcc_item, baseconf_item, conf_item, \
			re_item = key.split("-", 6);
		item = "-".join([arch_item, mach_item, ver_item, gcc_item, baseconf_item]);
		confs = conf_item.split('+');
		if re_item == re and (confs[0] in focusitems2 or cates[0] == "All") :
			if conf_item == "BASE" :
				continue;
			if conf_item == "NONE" :
				base_data1 = confdb2[key];
				continue;
			s = [];
			if sm == "Size" :
				if confdb2[key][0] == CP_FAIL :
					continue;
				for k in range(0,2) :
					s.append(confdb2[key][k]);
			elif sm == "Mem" :
				if CP_FAIL in confdb2[key] or MEM_FAIL in confdb2[key] :
					continue;
				for k in range(2,5) :
					s.append(confdb2[key][k]);
			else :
				if CP_FAIL in confdb2[key] or MEM_FAIL in confdb2[key] :
					continue;
				for k in range(0,5) :
					s.append(confdb2[key][k]);
			data2[conf_item] = s;
	confdb2.close();

	for i in range(len(data1)-1, -1, -1) :
		if data2.has_key(data1[i][0]) :
			if sm == "Size" :
				for j in range(1, 3) :
					data1[i][j] = -1 * (int(data1[i][j]) - int(data2[data1[i][0]][j-1]));
			elif sm == "Mem" :
				for j in range(1, 4) :
					data1[i][j] = -1 * (int(data1[i][j]) - int(data2[data1[i][0]][j-1]));
			else :
				for j in range(1, 6) :
					data1[i][j] = -1 * (int(data1[i][j]) - int(data2[data1[i][0]][j-1]));
		else :
			del data1[i];

	if sort_by == "" :
		data1.sort();
	else :
		sortWay = sort_by;
		data1.sort(compare_custom);
	
	data_item0 = [e[0][:11] for e in data1];
	if sm == "Size" :
		data_item1 = [int(e[1]) for e in data1];
		data_item2 = [int(e[2]) for e in data1];
		return (data_item0, data_item1, data_item2);
	elif sm == "Mem" :
		data_item1 = [int(e[1]) for e in data1];
		data_item2 = [int(e[2]) for e in data1];
		data_item3 = [int(e[3]) for e in data1];
		return (data_item0, data_item1, data_item2, data_item3);
	else :
		data_item1 = [int(e[1]) for e in data1];
		data_item2 = [int(e[2]) for e in data1];
		data_item3 = [int(e[3]) for e in data1];
		data_item4 = [int(e[4]) for e in data1];
		data_item5 = [int(e[5]) for e in data1];
		return (data_item0, data_item1, data_item2, data_item3, data_item4, data_item5);


# for drawing picture, get the data list of config item with a particular form from confdb that 
# match the cond and belone to the cates.
# parameter :
#	result_dir:	result dir of your test
#	category_file:	category file name of your test
#	confdb_name:	the db file's name of the configures
#	cond:		the string with format as arch-mach-ver-gcc-baseconfig
#	caters:		a list of categories such as "Device Drivers" etc.
#	sm:		the wanted data type(Size, Mem or All)
#	re:		the wanted data type(raw or effect)
#	sort_by:	the sort condition. it's format just like "3_0". the first number
#			is the sort index, where as the second number is the sort way. 1
#			means Ascendent while 0 means Descendent.
# return :
#	a tuple with the form such as ([item1_name,item2_name,...], [item1_data[0],item2_data[0],...], 
#	[item1_data[1],item2_data[1],...], [item1_data[2],item2_data[2],...], 
#	[item1_data[3],item2_data[3],...], ...,[item1_data[n],item2_data[n],...]).
def getConfData(result_dir, category_file, confdb_name, cond, cates, sm, re, sort_by) :
	global sortWay;
	arch, mach, ver, gcc, baseconf = cond.split("-", 4);
	if cates[0] != "All" :
		cate_path = confdb_name[0:-2] + "cat";
		focusitems = get_focusitems(cate_path, cates);
		focusitems.append("BASE");
		focusitems.append("NONE");
	else :
		focusitems = [];
	confdb = shelve.open(confdb_name, flag='r');
	keys = confdb.keys();
	data = [];
	base_data = [];
	for key in keys :
		arch_item, mach_item, ver_item, gcc_item, baseconf_item, conf_item, \
			re_item = key.split("-", 6);
		confs = conf_item.split('+');
		if re_item == re and (confs[0] in focusitems or cates[0] == "All") :
			if conf_item == "BASE" :
				continue;
			if conf_item == "NONE" :
				base_data = confdb[key];
				continue;
			s = [];
			if sm == "Size" :
				if CP_FAIL in confdb[key] :
					continue;
				for k in range(0,2) :
					s.append(confdb[key][k]);
			elif sm == "Mem" :
				if MEM_FAIL in confdb[key] or CP_FAIL in confdb[key] :
					continue;
				for k in range(2,5) :
					s.append(confdb[key][k]);
			else :
				if MEM_FAIL in confdb[key] or CP_FAIL in confdb[key] :
					continue;
				for k in range(0,5) :
					s.append(confdb[key][k]);
			s.insert(0, conf_item[:11]);
			data.append(s);
	confdb.close();
	
	if re == "raw" :
		for i in range(0, len(data)) :
			for j in range(1, len(data[i])) :
				if sm == "Mem" :
					data[i][j] = int(data[i][j]) - int(base_data[j+1]);
				else :
					data[i][j] = int(data[i][j]) - int(base_data[j-1]);

	if sort_by == "" :
		data.sort();
	else :
		sortWay = sort_by;
		data.sort(compare_custom);
			
	data_item0 = [e[0] for e in data];
	if sm == "Size" :
		data_item1 = [int(e[1]) for e in data];
		data_item2 = [int(e[2]) for e in data];
		return (data_item0, data_item1, data_item2);
	elif sm == "Mem" :
		data_item1 = [int(e[1]) for e in data];
		data_item2 = [int(e[2]) for e in data];
		data_item3 = [int(e[3]) for e in data];
		return (data_item0, data_item1, data_item2, data_item3);
	else :
		data_item1 = [int(e[1]) for e in data];
		data_item2 = [int(e[2]) for e in data];
		data_item3 = [int(e[3]) for e in data];
		data_item4 = [int(e[4]) for e in data];
		data_item5 = [int(e[5]) for e in data];
		return (data_item0, data_item1, data_item2, data_item3, data_item4, data_item5);
