/*
 * KconfigSize tool---common small functions
 * Copyright (C) 2005-2006 NEC-AS/NEC. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GPLv2, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Created by YongHua Zheng <zhengyh@sh.necas.nec.com.cn>
 * 2006-02-20 Modified by YongHua Zheng <zhengyh@sh.necas.nec.com.cn>
 */

#include "common.h"

void chomp (char *line)
{
	char * c;

	c = line + strlen (line);
	for (c; c >= line; c--) {
		if (strchr (" \t\n\r", *c))
			*c = '\0';
		else
			break;
	}
}

#if defined (__GNUC__)
__inline
#endif
static char *trimr(char *line)
{
	char * c;

	c = line + strlen (line);
	for (c; c >= line; c--) {
		if (strchr (" \t", *c))
			*c = '\0';
		else
			break;
	}

	return line;
}

#if defined (__GNUC__)
__inline
#endif
static char *triml (char *line)
{
	char *c, *end;

	end = line + strlen (line);
	for (c = line; c <= end && strchr (" \t", *c); c++);

	return c;
}

char *trim (char *line)
{
	return trimr (triml (line));
}
