/*
 * KconfigSize tool---common headers
 * Copyright (C) 2005-2006 NEC-AS/NEC. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GPLv2, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Created by YongHua Zheng <zhengyh@sh.necas.nec.com.cn>
 * 2006-02-20 Modified by YongHua Zheng <zhengyh@sh.necas.nec.com.cn>
 */

#ifndef _COMMON_H
#define _COMMON_H

#if defined (HAVE_CONFIG_H)
#include <config.h>
#endif /* HAVE_CONFIG_H */

#if defined (HAVE_SYS_TYPES_H)
#include <sys/types.h>
#endif /* HAVE_SYS_TYPES_H */

#if defined (HAVE_UNISTD_H)
#include <unistd.h>
#endif /* HAVE_UNISTD_H */

#if defined (HAVE_SYS_TIME_H)
#include <sys/time.h>
#endif /* HAVE_SYS_TIME_H */

#if defined (HAVE_SYS_RESOURCE_H)
#include <sys/resource.h>
#endif /* HAVE_SYS_RESOURCE_H */

#if defined (HAVE_SYS_WAIT_H)
#include <sys/wait.h>
#endif /* HAVE_SYS_WAIT_H */

#if defined (HAVE_STDARG_H) && defined (__STDC__) && __STDC__
#include <stdarg.h>
#endif

#if defined (STDC_HEADERS) || defined (HAVE_STDLIB_H)
#include <stdlib.h>
#endif /* HAVE_STDLIB_H */

#if defined (HAVE_SYS_STAT_H)
#include <sys/stat.h>
#endif /* HAVE_SYS_STAT_H */

#if defined (HAVE_FCNTL_H)
#include <fcntl.h>
#endif

#if defined (HAVE_LIBGEN_H)
#include <libgen.h>
#endif

#include <stdio.h>
#include <stddef.h>
#include <signal.h>
#include <getopt.h>
#include <string.h>
#include <assert.h>
#include <limits.h>
#include <errno.h>
#if !defined (errno)
extern int errno;
#endif

extern void chomp (char *line);
extern char *trim (char *line);

extern char *strsplit (char **s, const char *delimiter);
extern size_t stradd (char **dest, const char *src, size_t *n);

extern long fsize (const char *file);

extern int execl_command (const char *prog_name, ...);
extern int execv_command (const char *prog_name, const char *av[]);
extern int wait_child (pid_t child);

#if !defined (MIN_CHUNK)
#define MIN_CHUNK 64
#endif
extern int readline (int fd, void **bufptr, size_t *n);

#define SAFE_RW_ERROR ((size_t) -1)
#define FULL_RW_ERROR ((size_t) -1)

typedef ssize_t (*rw) (int fd, const void *buf, size_t count);
extern size_t full_rw (int fd, const void *buf, size_t count, rw rw_func);

#define full_read(x,y,z)	full_rw(x,y,z,read)
#define full_write(x,y,z)	full_rw(x,y,z,write)

extern void version (FILE *stream, const char *cmd_name, const char *package,
		const char *version, .../* authors */);

#define GETOPT_VERSION_CHAR 'v'
#define GETOPT_HELP_CHAR 'h'

#define GETOPT_HELP_OPTION_DECL		\
	"help", 0, 0, GETOPT_HELP_CHAR

#define GETOPT_VERSION_OPTION_DECL	\
	"version", 0, 0, GETOPT_VERSION_CHAR

#define case_GETOPT_VERSION_CHAR(cmd_name, authors)		\
	case GETOPT_VERSION_CHAR:				\
		version (stdout, cmd_name, PACKAGE_NAME,	\
				PACKAGE_VERSION, authors, NULL);\
		exit (0);					\
		break;

#define case_GETOPT_HELP_CHAR			\
	case GETOPT_HELP_CHAR:			\
		usage (0);			\
		break;

extern void warn (FILE *stream, const char *format, ...);

#endif /* _COMMON_H */
