/*
 * KconfigSize tool---size-common.c's header file
 * Copyright (C) 2005-2006 NEC-AS/NEC. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GPLv2, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Created by Lv Zheng <zhengl@sh.necas.nec.com.cn>
 * 2006-02-20 Modified by  Fan Wu<wuf@sh.necas.nec.com.cn>
 */
#ifndef _SIZE_COMMON_H
#define _SIZE_COMMON_H

#define TRUE	1
#define FALSE	0

extern signed char line[128];
extern int indent;
extern int conf_cnt;
extern int focus_no;
extern char *result_path;
extern char absolute_result_path[256];

extern void size_conf_value(struct symbol *sym, const char *def);
extern int size_conf_string(struct menu *menu);
extern int size_conf_sym(struct menu *menu);
extern void size_conf_menu(struct menu *menu);
extern void size_conf_check(struct menu *menu);
extern inline bool sym_is_const(struct symbol *sym);
extern inline tristate reverse_value(tristate val);
extern inline enum expr_type reverse_expr(enum expr_type type);
extern tristate size_get_tristate_value(struct symbol *sym);
extern const char *size_get_string_value(struct symbol *sym);
extern bool size_set_string_value(struct symbol *sym, const char *newval);
extern bool size_set_tristate_value(struct symbol *sym, tristate val);
extern tristate size_calc_expr(struct expr *e);
extern bool size_set_choice_value(struct symbol *entry, struct symbol *value);
extern void size_gen_config(void);
extern void size_print_symbol(FILE *out, struct menu *menu, struct menu *parent);
extern void size_print_menu(FILE *out);
extern void size_print_sub_menu(FILE *out, struct menu* menu, struct menu* parent);
extern void strip(signed char *str);
extern char* get_current_path(void);
extern char *combine_path(const char *path, const char *file);
extern int copy_file(const char *from, const char *to);

extern int size_conf_choice(struct menu *menu);

#endif /* _SIZE_COMMON_H */
