/*
 * KconfigSize tool---An interface to contentate strings
 * Copyright (C) 2005-2006 NEC-AS/NEC. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GPLv2, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Created by YongHua Zheng <zhengyh@sh.necas.nec.com.cn>
 * 2006-02-20 Modified by YongHua Zheng <zhengyh@sh.necas.nec.com.cn>
 */

#include "common.h"

size_t stradd (char **dest, const char *src, size_t *n)
{
	size_t avail;
	size_t len;
	char *tmptr = NULL;

	if (!src) {
		errno = EINVAL;
		return (size_t)-1;
	}

	len = strlen (src);
	if (!*dest) {
		*n = *n > len ? *n : len + 100;
		*dest = malloc (*n * sizeof (char));
		if (*dest)
			strcpy (*dest, src);
	}
	else {
		avail = *n - strlen (*dest);
		if (avail < len + 1) {
			if (len > 100)
				*n += (2 * len);
			else
				*n += (len + 100);
			tmptr = realloc (*dest, *n * sizeof (char));
			/* make sure it succeded */
			if (!tmptr) {
				free (*dest);
				*dest = NULL;
				/* Not direct return */
			}
			else
			/* then set it */
				*dest = tmptr;
		}
		if (*dest)
			strcat (*dest, src);
	}

	assert (*dest);

	return strlen (*dest);
}
