/*
 * KconfigSize tool---Split string into units with specific delimiters
 * Copyright (C) 2005-2006 NEC-AS/NEC. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GPLv2, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Created by YongHua Zheng <zhengyh@sh.necas.nec.com.cn>
 * 2006-02-20 Modified by YongHua Zheng <zhengyh@sh.necas.nec.com.cn>
 */

#include "common.h"

char *strsplit (char **s, const char *delimiter)
{
	char *p, *ret, *end;

	assert (*s);

	if (**s== '\0')
		return NULL;

	end = *s+ strlen (*s);
	for (p = *s; p < end; p++) {
		if (strchr (delimiter, *p))
			break;
	}

	if (*p != '\0')
		*p++ = '\0';

	ret = trim (*s);
	*s = p;

	return ret;
}
