/*
 * KconfigSize tool---version output in a consisten format.
 * Copyright (C) 2005-2006 NEC-AS/NEC. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GPLv2, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Created by YongHua Zheng <zhengyh@sh.necas.nec.com.cn>
 * 2006-02-20 Modified by YongHua Zheng <zhengyh@sh.necas.nec.com.cn>
 */

#include "common.h"

/* Default copyrights */
const char *copyright = 
  "Copyright (C) 2005-2006 NEC-AS/NEC. All rights reserved.";
const char *copyright_desc =
  "This is free software; see the source for copying conditions.  There is NO\n\
warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.\n";

static void va_version (FILE *stream, const char *cmd_name, const char *package,
		const char *version, va_list authors)
{
	int n_authors;
	va_list cp_authors;

	va_copy (cp_authors, authors);

	/* Count the number of authors */
	n_authors = 0;
	while (va_arg (cp_authors, const char *) != NULL)
		n_authors++;

	fprintf (stream, "%s (%s) %s\n", cmd_name, package, version);

	switch (n_authors) {
		case 0:
			break;

		case 1:
			vfprintf (stream, "Written by %s.\n", authors);
			break;

		case 2:
			vfprintf (stream, "Written by %s and %s.\n", authors);
			break;

		case 3:
			vfprintf (stream, "Written by %s, %s and %s.\n",
					authors);
			break;

		case 4:
			vfprintf (stream, "Written by %s, %s, %s and %s.\n",
					authors);
			break;

		case 5:
			vfprintf (stream, "Written by %s, %s, %s, %s and %s.\n",
					authors);
			break;

		default:
			vfprintf (stream, "\
Written by %s, %s, %s, %s, %s, %s and others.\n", authors);
			break;
	}
	va_end (authors);
	putc ('\n', stream);

	/* prints copyright info */
	fputs (copyright, stream);
	putc ('\n', stream);

	/* prints extra copyright info */
	fputs (copyright_desc , stream);
}

void version (FILE *stream, const char *cmd_name, const char *package,
		const char *version, ...)
{
	va_list authors;

	va_start (authors, version);
	va_version (stream, cmd_name, package, version, authors);
}
